Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT

## javax.persistence
Annotation Type JoinColumn

    @Target(value={METHOD,FIELD})
    @Retention(value=RUNTIME)
    public @interface JoinColumn

Specifies a column for joining an entity association or element collection. If the `JoinColumn` annotation itself is defaulted, a single join column is assumed and the default values apply.

       Example:

       @ManyToOne
       @JoinColumn(name="ADDR_ID")
       public Address getAddress() { return address; }

       Example: unidirectional one-to-many association using a foreign key mapping

       // In Customer class
       @OneToMany
       @JoinColumn(name="CUST_ID") // join column is in table for Order
       public Set<Order> getOrders() {return orders;}

Since:
  Java Persistence 1.0
See Also:
  `ManyToOne`, `OneToMany`, `OneToOne`, `JoinTable`, `CollectionTable`

Optional Element Summary
`java.lang.String` | `columnDefinition` (Optional) The SQL fragment that is used when generating the DDL for the column.
`boolean` | `insertable` (Optional) Whether the column is included in SQL INSERT statements generated by the persistence provider.
`java.lang.String` | `name` (Optional) The name of the foreign key column.
`boolean` | `nullable` (Optional) Whether the foreign key column is nullable.
`java.lang.String` | `referencedColumnName` (Optional) The name of the column referenced by this foreign key column.
`java.lang.String` | `table` (Optional) The name of the table that contains the column.
`boolean` | `unique` (Optional) Whether the property is a unique key.
`boolean` | `updatable` (Optional) Whether the column is included in SQL UPDATE statements generated by the persistence provider.

### name

    public abstract java.lang.String name

  (Optional) The name of the foreign key column. The table in which it is found depends upon the context.
  - If the join is for a OneToOne or ManyToOne mapping using a foreign key mapping strategy, the foreign key column is in the table of the source entity or embeddable.
  - If the join is for a unidirectional OneToMany mapping using a foreign key mapping strategy, the foreign key is in the table of the target entity.
  - If the join is for a ManyToMany mapping or for a OneToOne or bidirectional ManyToOne/OneToMany mapping using a join table, the foreign key is in a join table.
  - If the join is for an element collection, the foreign key is in a collection table.

  Default (only applies if a single join column is used): The concatenation of the following: the name of the referencing relationship property or field of the referencing entity or embeddable class; "_"; the name of the referenced primary key column. If there is no such referencing relationship property or field in the entity, or if the join is for an element collection, the join column name is formed as the concatenation of the following: the name of the entity; "_"; the name of the referenced primary key column.

  Default:
    ""

### referencedColumnName

    public abstract java.lang.String referencedColumnName

  (Optional) The name of the column referenced by this foreign key column.
  - When used with entity relationship mappings other than the cases described here, the referenced column is in the table of the target entity.
  - When used with a unidirectional OneToMany foreign key mapping, the referenced column is in the table of the source entity.
  - When used inside a `JoinTable` annotation, the referenced key column is in the entity table of the owning entity, or inverse entity if the join is part of the inverse join definition.
  - When used in a `CollectionTable` mapping, the referenced column is in the table of the entity containing the collection.

  Default (only applies if single join column is being used): The same name as the primary key column of the referenced table.

  Default:
    ""

### unique

    public abstract boolean unique

  (Optional) Whether the property is a unique key. This is a shortcut for the `UniqueConstraint` annotation at the table level and is useful for when the unique key constraint is only a single field. It is not necessary to explicitly specify this for a join column that corresponds to a primary key that is part of a foreign key.

  Default:
    false

### nullable

    public abstract boolean nullable

  (Optional) Whether the foreign key column is nullable.

  Default:
    true

### insertable

    public abstract boolean insertable

  (Optional) Whether the column is included in SQL INSERT statements generated by the persistence provider.

  Default:
    true

### updatable

    public abstract boolean updatable

  (Optional) Whether the column is included in SQL UPDATE statements generated by the persistence provider.

  Default:
    true

### columnDefinition

    public abstract java.lang.String columnDefinition

  (Optional) The SQL fragment that is used when generating the DDL for the column.

  Defaults to the generated SQL for the column.

  Default:
    ""

### table

    public abstract java.lang.String table

  (Optional) The name of the table that contains the column. If a table is not specified, the column is assumed to be in the primary table of the applicable entity.

  Default:

  - If the join is for a OneToOne or ManyToOne mapping using a foreign key mapping strategy, the name of the table of the source entity or embeddable.
  - If the join is for a unidirectional OneToMany mapping using a foreign key mapping strategy, the name of the table of the target entity.
  - If the join is for a ManyToMany mapping or for a OneToOne or bidirectional ManyToOne/OneToMany mapping using a join table, the name of the join table.
  - If the join is for an element collection, the name of the collection table.

  Default:
    ""

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT